#include "mex.h"
#include "matrix.h"
#define API_MODE_2
static unsigned char checksum;
const int DATATYPE_BYTELENGTH = 4;
const int DATA_ARRAY_LENGTH = 10;
const int ADDITIONAL_NUMS = 8;


void assemblePacket_HB(unsigned char outPacket[], float rawData[], unsigned int *ADDR){
    
    
    unsigned int destination;
	unsigned int i; //i is the index
	unsigned int j;//j is for splitting up signed int into BYTEs
	union packetFloat{
        float dataFloat;
        unsigned char dataChar[4];
    } tempFloatUnion;
        
	unsigned int index=0;
	unsigned int *indexPtr;
	indexPtr=&index;
    
    if (*ADDR==0)
        destination = 0xFFFF;
    else
        destination = *ADDR;

//assemble outPacket
	initPacket(outPacket,indexPtr); 
	loadByte(outPacket,0x01,indexPtr);
	loadByte(outPacket,0x01,indexPtr);
	loadByte(outPacket,destination/256,indexPtr);
	loadByte(outPacket,destination%256,indexPtr);
	loadByte(outPacket,0x00,indexPtr);
	
	for (i=0; i<(DATA_ARRAY_LENGTH+ADDITIONAL_NUMS); i++){
		tempFloatUnion.dataFloat=rawData[i];
		//you can only send single bytes at a timeto the serial port, so use a UNION to chop up the 32-bit float.
		for (j=0; j<DATATYPE_BYTELENGTH; j++){	
			loadByte(outPacket,tempFloatUnion.dataChar[DATATYPE_BYTELENGTH-1-j],indexPtr); //read in byte
		}
	}
	loadByte(outPacket,0xFF-checksum,indexPtr);
}

void initPacket(unsigned char outPacket[], unsigned int *pIndex){
	// For packet structure, see XBee User's Manual 3.4.2 (API Types): TX Request (16-bit address)
	
	unsigned int packet_length;
	packet_length = ((DATA_ARRAY_LENGTH+ADDITIONAL_NUMS)*DATATYPE_BYTELENGTH+5);
	//	Packet length in bytes: 
	//	Add 5 bytes to data length for: 
	//	1. API identifier
	//	2. Frame ID
	//	3. Destination address high byte
	//	4. Destination address low byte
	//	5. Options byte	
	
	*pIndex=0;
	checksum=0;	
	outPacket[*pIndex]=0x7E;
	*pIndex+=1;
	outPacket[*pIndex]=packet_length/256; 
	//Packet length,high byte.  
	
	
#if defined API_MODE_2
	if (outPacket[*pIndex] == 0x7E ||
		outPacket[*pIndex] == 0x7D ||
		outPacket[*pIndex] == 0x11 ||
		outPacket[*pIndex] == 0x13){	
		outPacket[*pIndex+1] = outPacket[*pIndex]^0x20;
		outPacket[*pIndex] = 0x7D;
		*pIndex+=1;
	}
#endif
	
	*pIndex+=1;
	outPacket[*pIndex]=packet_length%256;    //Packet length, low byte
	
#if defined API_MODE_2
	if (outPacket[*pIndex] == 0x7E ||
		outPacket[*pIndex] == 0x7D ||
		outPacket[*pIndex] == 0x11 ||
		outPacket[*pIndex] == 0x13){	
		outPacket[*pIndex+1] = outPacket[*pIndex]^0x20;
		outPacket[*pIndex] = 0x7D;
		*pIndex+=1;
	}
#endif
	*pIndex+=1;
}

void loadByte(unsigned char outPacket[],unsigned char byte, unsigned int *pIndex){
	outPacket[*pIndex]=byte;
	checksum+=outPacket[*pIndex];
	
#if defined API_MODE_2
	if (outPacket[*pIndex] == 0x7E ||
		outPacket[*pIndex] == 0x7D ||
		outPacket[*pIndex] == 0x11 ||
		outPacket[*pIndex] == 0x13){	
		outPacket[*pIndex+1] = outPacket[*pIndex]^0x20;
		outPacket[*pIndex] = 0x7D;
		*pIndex+=1;
	}
#endif
	*pIndex+=1;
}



void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[])
{
    float *outArray;
    
    plhs[0] = mxCreateNumericMatrix(1,90,mxUINT8_CLASS, mxREAL);
    outArray = mxGetPr(plhs[0]);
    
    assemblePacket_HB(outArray, mxGetPr(prhs[0]), mxGetPr(prhs[1]));
}