% FFT some color data

function fftcolordata(colordata);


red = colordata(1,:);
green = colordata(2,:);
blue = colordata(3,:);

subplot(2, 2, 1);
set(gca,'ColorOrder',[1 0 0; 0 1 0; 0 0 1],'NextPlot','ReplaceChildren')
    
plot(colordata');
title('time domain');


Fs = 2.5;                    % Sampling frequency
T = 1/Fs;                     % Sample time
L = length(red);                     % Length of signal
t = (0:L-1)*T;                % Time vector

% put in your data
y = red;     

NFFT = 2^nextpow2(L); % Next power of 2 from length of y
Y = fft(y,NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2+1);

% Plot single-sided amplitude spectrum.
subplot(2, 2, 2);
plot(f,2*abs(Y(1:NFFT/2+1))) 
title('red')
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')


% put in your data
y = green;     

NFFT = 2^nextpow2(L); % Next power of 2 from length of y
Y = fft(y,NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2+1);

% Plot single-sided amplitude spectrum.
subplot(2, 2, 3);
plot(f,2*abs(Y(1:NFFT/2+1))) 
title('green')
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')


% put in your data
y = blue;     

NFFT = 2^nextpow2(L); % Next power of 2 from length of y
Y = fft(y,NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2+1);

% Plot single-sided amplitude spectrum.
subplot(2, 2, 4);
plot(f,2*abs(Y(1:NFFT/2+1))) 
title('blue')
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')