% projectorRGB_relationship.m
% Sam Bobb, Summer 2009
% Run after RGB_avg_std_logger, to create "color sweep" plots

% shows projector color relationship


% Change this according to what you actually did with the projector
% This is your X-axis
projectorvalue = 0:10:250;
projectorvalue = [projectorvalue, 255];


hold on;

% make plots with error bars as the std.
errorbar(projectorvalue, R_stats_log(1,:), R_stats_log(2,:), '.:r')

errorbar(projectorvalue, G_stats_log(1,:), G_stats_log(2,:), '.:g')

errorbar(projectorvalue, B_stats_log(1,:), B_stats_log(2,:), '.:b')

title('Projector vs ADC values')

xlabel('Projector (Black->Gray->White)')

ylabel('Puck ADC')

hold off;

figure
plot(projectorvalue, R_stats_log(2,:), '.:r', projectorvalue, G_stats_log(2,:), '.:g', projectorvalue, B_stats_log(2,:), '.:b', 'LineWidth', 2, 'MarkerSize', 15)

title('Projector vs ADC standard deviation')
xlabel('Projector (Black->Gray->White)')
ylabel('Puck ADC std')


figure
plot(projectorvalue, 100*R_stats_log(2,:)./R_stats_log(1,:), '.:r', projectorvalue, 100*G_stats_log(2,:)./G_stats_log(1,:), '.:g', projectorvalue, 100*B_stats_log(2,:)./B_stats_log(1,:), '.:b', 'LineWidth', 2, 'MarkerSize', 15)

title('Projector vs ADC standard deviation as percent of ADC value')
xlabel('Projector (Black->Gray->White)')
ylabel('Puck ADC std')

